/**********************************************************

This software is part of J.-S. Caux's ABACUS library.

Copyright (c) J.-S. Caux.

-----------------------------------------------------------

File:  src/ODSLF/ODSLF_Chem_Pot.cc

Purpose:  calculates the chemical potential.

***********************************************************/

#include "ABACUS.h"

namespace ABACUS {

  DP Chemical_Potential (const ODSLF_Bethe_State& RefState)
  {
    return(-H_vs_M (RefState.chain.Delta, RefState.chain.Nsites, RefState.base.Mdown));  // - sign since E_{M+1} - E_M = -H
  }

}
